(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["pmxOverlay"] = factory();
	else
		root["pmxOverlay"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = overlay;
	
	var _pmxUtilDom = __webpack_require__(1);
	
	function __onActivate(_ref, paramTargetEl) {
	  var el = _ref.el,
	      targetEl = _ref.targetEl,
	      focus = _ref.focus,
	      css = _ref.css,
	      onActivateHandler = _ref.onActivateHandler,
	      config = _ref.config;
	  var applyClassOnBodyOnActivate = config.applyClassOnBodyOnActivate,
	      initialFocusSelector = config.initialFocusSelector;
	  var classes = css.classes;
	
	
	  if (targetEl === paramTargetEl) {
	    (0, _pmxUtilDom.__removeClass)({ el: el, className: classes.get('deactivated') });
	    __addCSSClass({
	      el: el,
	      className: classes.get('activated'),
	      config: config
	    });
	
	    if (applyClassOnBodyOnActivate) {
	      __addCSSClass({
	        el: document.body,
	        className: classes.get('globalactive'),
	        config: config
	      });
	    }
	
	    if (typeof onActivateHandler === 'function') {
	      onActivateHandler({ el: el, targetEl: targetEl, focus: focus, css: css });
	    }
	
	    if (document.querySelector(initialFocusSelector)) {
	      focus.activate();
	    }
	  }
	}
	
	function __onDeactivate(_ref2, paramTargetEl) {
	  var el = _ref2.el,
	      targetEl = _ref2.targetEl,
	      focus = _ref2.focus,
	      css = _ref2.css,
	      onDeactivateHandler = _ref2.onDeactivateHandler,
	      config = _ref2.config;
	  var applyClassOnBodyOnActivate = config.applyClassOnBodyOnActivate;
	  var classes = css.classes;
	
	  if (targetEl === paramTargetEl) {
	    (0, _pmxUtilDom.__removeClass)({ el: el, className: classes.get('activated') });
	    if (applyClassOnBodyOnActivate) {
	      (0, _pmxUtilDom.__removeClass)({ el: document.body, className: classes.get('globalactive') });
	    }
	    __addCSSClass({
	      el: el,
	      className: classes.get('deactivated'),
	      config: config
	    });
	    if (typeof onDeactivateHandler === 'function') {
	      onDeactivateHandler({ el: el, targetEl: targetEl, focus: focus, css: css });
	    }
	    focus.deactivate();
	  }
	}
	
	function __onClickOutside(_ref3) {
	  var config = _ref3.config,
	      shared = _ref3.shared;
	  var events = config.events,
	      targetEl = config.targetEl;
	  var emitter = shared.emitter;
	
	
	  emitter.emit(events.get('deactivate'), targetEl);
	}
	
	function __attachListeners(_ref4) {
	  var config = _ref4.config,
	      shared = _ref4.shared;
	  var el = config.el,
	      targetEl = config.targetEl,
	      events = config.events,
	      css = config.css,
	      onActivateHandler = config.onActivateHandler,
	      onDeactivateHandler = config.onDeactivateHandler,
	      addedEventListeners = config.addedEventListeners,
	      initialFocusSelector = config.initialFocusSelector;
	  var emitter = shared.emitter,
	      focusTrap = shared.focusTrap;
	
	  var registeredListeners = [];
	  var focusConfig = {
	    onDeactivate: function onDeactivate() {
	      if (typeof onDeactivateHandler === 'function') {
	        onDeactivateHandler({ el: el, targetEl: targetEl });
	      }
	    },
	
	    escapeDeactivates: false,
	    returnFocusOnDeactivate: false
	  };
	
	  if (initialFocusSelector) {
	    focusConfig.initialFocus = initialFocusSelector;
	  }
	
	  var focus = focusTrap(targetEl, focusConfig);
	  var handlers = new Map([['activate', __onActivate.bind(null, { el: el, targetEl: targetEl, focus: focus, css: css, onActivateHandler: onActivateHandler, config: config })], ['deactivate', __onDeactivate.bind(null, { el: el, targetEl: targetEl, focus: focus, css: css, onDeactivateHandler: onDeactivateHandler, config: config })], ['clickoutside', __onClickOutside.bind(null, { config: config, shared: shared, focus: focus })]]);
	
	  el.addEventListener('click', handlers.get('clickoutside'), false);
	  registeredListeners.push({
	    eventType: 'click',
	    handler: handlers.get('clickoutside')
	  });
	  addedEventListeners.set(el, registeredListeners);
	
	  events.forEach(function (evt, type) {
	    emitter.on(evt, handlers.get(type));
	  });
	}
	
	function __checkAndGetElement(_ref5) {
	  var el = _ref5.el,
	      type = _ref5.type;
	
	  var errorMsg = '[pmx-overlay] ' + type + ' needs to be DOM element or a valid selector for .querySelector()';
	  var validEl = void 0;
	  if (el === undefined || el.nodeName === undefined && typeof el !== 'string') {
	    throw new Error(errorMsg);
	  } else if (typeof el === 'string') {
	    try {
	      validEl = document.querySelector(el);
	    } catch (e) {
	      throw new Error(errorMsg);
	    }
	  } else if (el.nodeName) {
	    validEl = el;
	  }
	
	  return validEl;
	}
	
	function __removeListeners(_ref6) {
	  var config = _ref6.config,
	      shared = _ref6.shared;
	  var addedEventListeners = config.addedEventListeners,
	      events = config.events;
	  var emitter = shared.emitter;
	
	
	  events.forEach(function (evt, type) {
	    emitter.removeAllListeners(type);
	  });
	
	  addedEventListeners.forEach(function (options, elem) {
	    if (Array.isArray(options)) {
	      options.forEach(function (option) {
	        elem.removeEventListener(option.eventType, option.handler);
	      });
	    } else {
	      elem.removeEventListener(options.eventType, options.handler);
	    }
	  });
	}
	
	function __addCSSClass(_ref7) {
	  var el = _ref7.el,
	      className = _ref7.className,
	      config = _ref7.config;
	
	  var cssClasses = [];
	  var mutatedElementsByCSS = config.mutatedElementsByCSS;
	
	
	  if (typeof className === 'string') {
	    cssClasses.push(className);
	  } else if (Array.isArray(className)) {
	    /**
	     * for now we won't support 'level' classes when passing an array
	     * as a parameter to avoid adding too many css classes to each elem
	     */
	    cssClasses = className;
	  } else {
	    throw new Error('there is a error with the type of the passed CSS classes');
	  }
	
	  // css classes filtering the ones that are empty
	  var classesToBeApplied = cssClasses.filter(function (item) {
	    return item;
	  });
	  // add the classes to the DOM elem
	  (0, _pmxUtilDom.__addClass)({ el: el, className: classesToBeApplied });
	
	  if (mutatedElementsByCSS.has(el)) {
	    mutatedElementsByCSS.get(el).push(classesToBeApplied);
	  } else {
	    mutatedElementsByCSS.set(el, classesToBeApplied);
	  }
	
	  return classesToBeApplied;
	}
	
	function __removeOverlay(_ref8) {
	  var config = _ref8.config,
	      shared = _ref8.shared;
	  var mutatedElementsByCSS = config.mutatedElementsByCSS;
	
	
	  mutatedElementsByCSS.forEach(function (classes, elem) {
	    (0, _pmxUtilDom.__removeClass)({ el: elem, className: classes });
	  });
	
	  __removeListeners({ config: config, shared: shared });
	}
	
	function overlay() {
	  return {
	    init: function init(cfg, shared) {
	      var config = Object.assign({
	        mutatedElementsByCSS: new Map(), // Map to keep track of mutated DOM elements. Handy to remove all the CSS classes when stoping the component
	        events: new Map([['activate', 'pmx:activate'], // the overlay will get activated when this event (along the
	        // targetEl) gets triggered
	        ['deactivate', 'pmx:deactivate']]),
	        css: {
	          classes: new Map([['overlayElement', 'Overlay'], ['activated', 'is-active'], ['deactivated', 'is-deactivated'], ['globalactive', 'Overlay--isactive']])
	        },
	        applyClassOnBodyOnActivate: true }, cfg);
	
	      config.el = __checkAndGetElement({ el: config.el, type: 'el' });
	      config.targetEl = __checkAndGetElement({ el: config.targetEl, type: 'targetEl' });
	      config.addedEventListeners = new Map(); // Map to keep track of added Event Listeners. Handy to remove all the listeners when stoppping the component
	      this.config = config;
	      __attachListeners({ config: config, shared: shared });
	    },
	    stop: function stop(config, shared) {
	      if (config) {
	        Object.assign(this.config, config);
	      }
	      __removeOverlay({ config: this.config, shared: shared });
	    }
	  };
	}

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	(function webpackUniversalModuleDefinition(root, factory) {
		if(true)
			module.exports = factory();
		else if(typeof define === 'function' && define.amd)
			define([], factory);
		else if(typeof exports === 'object')
			exports["pmxUtilDom"] = factory();
		else
			root["pmxUtilDom"] = factory();
	})(this, function() {
	return /******/ (function(modules) { // webpackBootstrap
	/******/ 	// The module cache
	/******/ 	var installedModules = {};
	/******/
	/******/ 	// The require function
	/******/ 	function __webpack_require__(moduleId) {
	/******/
	/******/ 		// Check if module is in cache
	/******/ 		if(installedModules[moduleId])
	/******/ 			return installedModules[moduleId].exports;
	/******/
	/******/ 		// Create a new module (and put it into the cache)
	/******/ 		var module = installedModules[moduleId] = {
	/******/ 			exports: {},
	/******/ 			id: moduleId,
	/******/ 			loaded: false
	/******/ 		};
	/******/
	/******/ 		// Execute the module function
	/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
	/******/
	/******/ 		// Flag the module as loaded
	/******/ 		module.loaded = true;
	/******/
	/******/ 		// Return the exports of the module
	/******/ 		return module.exports;
	/******/ 	}
	/******/
	/******/
	/******/ 	// expose the modules object (__webpack_modules__)
	/******/ 	__webpack_require__.m = modules;
	/******/
	/******/ 	// expose the module cache
	/******/ 	__webpack_require__.c = installedModules;
	/******/
	/******/ 	// __webpack_public_path__
	/******/ 	__webpack_require__.p = "";
	/******/
	/******/ 	// Load entry module and return exports
	/******/ 	return __webpack_require__(0);
	/******/ })
	/************************************************************************/
	/******/ ([
	/* 0 */
	/***/ function(module, exports) {
	
		'use strict';
		
		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		exports.__addClass = __addClass;
		exports.__removeClass = __removeClass;
		exports.__hasClass = __hasClass;
		exports.__getDirectChilds = __getDirectChilds;
		exports.__hasSubmenu = __hasSubmenu;
		exports.__getItemLevel = __getItemLevel;
		exports.__getItemAtLevel = __getItemAtLevel;
		exports.__isFirstDescendant = __isFirstDescendant;
		exports.__isLastDescendant = __isLastDescendant;
		exports.__isSubmenuOpen = __isSubmenuOpen;
		exports.__getItemHeight = __getItemHeight;
		exports.__generateUID = __generateUID;
		exports.__closest = __closest;
		exports.__hasClassName = __hasClassName;
		exports.__closestByClassName = __closestByClassName;
		exports.__checkAndGetElement = __checkAndGetElement;
		exports.__getFocusableElements = __getFocusableElements;
		exports.__unsetItemHeight = __unsetItemHeight;
		exports.__setItemHeight = __setItemHeight;
		function __addClass(_ref) {
		  var el = _ref.el,
		      className = _ref.className;
		
		  if (!el) return;
		  if (el.className === '' && typeof className === 'string') return el.className = className; // eslint-disable-line
		  var classes = el.className.split(' ');
		  if (Array.isArray(className)) {
		    className.forEach(function (cn) {
		      if (classes.indexOf(cn) === -1) {
		        classes.push(cn);
		      }
		    });
		  } else if (typeof className === 'string') {
		    if (classes.indexOf(className) > -1) return classes; // eslint-disable-line
		    classes.push(className);
		  }
		  var nonEmptyClasses = classes.filter(function (elem) {
		    return elem;
		  });
		  el.className = nonEmptyClasses.join(' '); // eslint-disable-line
		}
		
		function __removeClass(_ref2) {
		  var el = _ref2.el,
		      className = _ref2.className;
		
		  if (!el) return;
		  if (el.className === '') return;
		  var classes = el.className.split(' ');
		  if (Array.isArray(className)) {
		    className.forEach(function (cn) {
		      var index = classes.indexOf(cn);
		      if (index > -1) classes.splice(index, 1);
		    });
		  } else if (typeof className === 'string') {
		    var index = classes.indexOf(className);
		    if (index > -1) classes.splice(index, 1);
		  }
		
		  el.className = classes.join(' '); // eslint-disable-line
		}
		
		function __hasClass(_ref3) {
		  var el = _ref3.el,
		      className = _ref3.className;
		
		  if (!el) return;
		  var classes = el.className.split(' ');
		  return classes.indexOf(className) > -1; // eslint-disable-line
		}
		
		/**
		 * function to grab the direct child of a passed elem
		 */
		function __getDirectChilds(parent, selector) {
		  var results = [].filter.call(parent.querySelectorAll(selector), function (element) {
		    return element.parentNode === parent;
		  });
		
		  if (results.length === 1) {
		    return results[0];
		  } else if (results.length === 0) {
		    return null;
		  }
		
		  return results;
		}
		
		/**
		 * simple util function to detect if an element contains a submenu
		 * @param  {[dom elem]}  item
		 * @return {Boolean}
		 */
		function __hasSubmenu(item) {
		  var submenu = __getDirectChilds(item, 'ul');
		  return submenu || false;
		}
		
		function __getItemLevel(_ref4) {
		  var item = _ref4.item,
		      levelIdentifier = _ref4.levelIdentifier;
		
		  var re = new RegExp(levelIdentifier + '-(\\d)');
		  var levelClasses = Array.from(item.classList).filter(function (cls) {
		    return cls.indexOf(levelIdentifier) !== -1;
		  }).map(function (cls) {
		    var result = re.exec(cls);
		    return result[1];
		  });
		  return levelClasses[0] && parseInt(levelClasses[0], 10);
		}
		
		function __getItemAtLevel(_ref5) {
		  var limitParent = _ref5.limitParent,
		      levelIdentifier = _ref5.levelIdentifier,
		      item = _ref5.item,
		      level = _ref5.level,
		      type = _ref5.type;
		
		  var closestByClassName = __closest.bind(null, __hasClassName, limitParent);
		
		  return closestByClassName(item, type + '--' + levelIdentifier + '-' + level);
		}
		
		function __isFirstDescendant(_ref6) {
		  var item = _ref6.item,
		      classSelector = _ref6.classSelector;
		
		  return item.parentNode && item.parentNode.classList.contains(classSelector) && item.previousElementSibling === null;
		}
		
		function __isLastDescendant(_ref7) {
		  var item = _ref7.item,
		      classSelector = _ref7.classSelector;
		
		  return item.parentNode && item.parentNode.classList.contains(classSelector) && item.nextElementSibling === null;
		}
		
		function __isSubmenuOpen(item, activeClass) {
		  var hasAriaExpanded = item && item.getAttribute('aria-expanded') === 'true';
		  var hasActiveClass = void 0;
		
		  if (activeClass) {
		    hasActiveClass = activeClass && item && item.classList.contains(activeClass);
		  }
		
		  return hasAriaExpanded || hasActiveClass;
		}
		
		function __getItemHeight(item) {
		  var style = item.style;
		  //	set auto height and read offsetHeight
		
		  style.height = 'auto';
		  var height = item.offsetHeight;
		  //	remove style
		  style.height = '';
		  return height;
		}
		
		function __generateUID(_ref8) {
		  var _ref8$length = _ref8.length,
		      length = _ref8$length === undefined ? 6 : _ref8$length,
		      namespace = _ref8.namespace;
		
		  return '' + Math.round(Math.pow(36, length + 1) - Math.random() * Math.pow(36, length)).toString(36).slice(1) + (namespace ? '-' + namespace : '');
		}
		
		function __closest(fn, limitParent, el, selector) {
		  if (limitParent === el) {
		    if (fn(el, selector)) {
		      return limitParent;
		    }
		    /**
		     * if we get here it means we didn't find the element.
		     */
		    return null;
		  }
		  return el && (fn(el, selector) ? el : __closest(fn, limitParent, el.parentNode, selector));
		}
		
		function __hasClassName(el, className) {
		  return el && el.classList && el.classList.contains(className);
		}
		
		function __closestByClassName(_ref9) {
		  var el = _ref9.el,
		      selector = _ref9.selector,
		      _ref9$limitElement = _ref9.limitElement,
		      limitElement = _ref9$limitElement === undefined ? document.body : _ref9$limitElement;
		
		  return __closest(__hasClassName, limitElement, el, selector);
		}
		
		function __checkAndGetElement(_ref10) {
		  var el = _ref10.el;
		
		  var errorMsg = '[pmx-util-dom] el needs to be DOM element or a valid selector for .querySelector()';
		  var validEl = void 0;
		  if (el === undefined || el.nodeName === undefined && typeof el !== 'string') {
		    throw new Error(errorMsg);
		  } else if (typeof el === 'string') {
		    try {
		      validEl = document.querySelector(el);
		    } catch (e) {
		      throw new Error(errorMsg);
		    }
		  } else if (el.nodeName) {
		    validEl = el;
		  }
		
		  return validEl;
		}
		
		function __getFocusableElements(_ref11) {
		  var parent = _ref11.parent;
		
		  var focusableElementsString = 'a[href], area[href], input:not([disabled]), select:not([disabled]), textarea:not([disabled]), button:not([disabled]), iframe, object, embed, [tabindex], [contenteditable]';
		
		  if (!parent) {
		    return [];
		  }
		
		  return Array.from(parent.querySelectorAll(focusableElementsString));
		}
		
		function __unsetItemHeight(_ref12) {
		  var item = _ref12.item;
		
		  var itemHeight = __getItemHeight(item);
		  var style = item.style;
		  // set item height from 'auto' to px
		
		  style.height = itemHeight + 'px';
		  // recalc style and layout
		  item.getBoundingClientRect();
		  // reset height
		  style.height = 0;
		}
		
		function __onTransitionEnd(_ref13) {
		  var item = _ref13.item,
		      transitionEndHandler = _ref13.transitionEndHandler;
		  var style = item.style;
		
		  style.transition = 'none';
		  style.height = 'auto';
		  // recalc style and layout
		  item.getBoundingClientRect();
		  style.transition = '';
		
		  item.removeEventListener('transitionend', transitionEndHandler);
		}
		
		function __setItemHeight(_ref14) {
		  var item = _ref14.item,
		      config = _ref14.config;
		
		  var itemHeight = __getItemHeight(item);
		  var style = item.style;
		
		
		  item.removeEventListener('transitionend', config.transitionEndHandler);
		  config.transitionEndHandler = __onTransitionEnd.bind(null, { item: item, transitionEndHandler: config.transitionEndHandler }); // eslint-disable-line
		  // force recalc style and layout
		  item.getBoundingClientRect();
		  // set height on item, reset to 'auto' on transition complete
		  style.height = itemHeight + 'px';
		  item.addEventListener('transitionend', config.transitionEndHandler);
		}
	
	/***/ }
	/******/ ])
	});
	;
	//# sourceMappingURL=pmx-util-dom.js.map

/***/ }
/******/ ])
});
;
//# sourceMappingURL=pmx-overlay.js.map